# $Id: 05_refresh.t,v 1.1 2007/10/05 11:35:43 pythontech Exp $
use strict;
use Test::More tests => 3;

use lib 't/lib';
use DbUtil;

use PythonTech::Triples::DBHash;
use DB_File;

my $dbname = 't/t05.3db';

# Create test data
dbwrite($dbname, '
v1 = a
v2 = b
v3 = c
ia = 1
ib = 2
ic = 3
l = 3
t1,2,3 = 1
o1,2 = 3
s2,3 = 1
');
sleep(2);

my $tr = new PythonTech::Triples::DBHash(filename => $dbname,
					 access => 'r');
is(&qt($tr->query('a','b',undef)), 'c', 'query sp?');

# Change database while we have it open
dbwrite("$dbname.new",'
v1 = b
v2 = d
v3 = a
ia = 3
ib = 1
id = 2
l = 3
t3,1,2 = 1
o3,1 = 2
s1,2 = 3
');
rename("$dbname.new",$dbname);

is(&qt($tr->query('a','b',undef)), 'c', 'before refresh');
$tr->can('refresh') && $tr->refresh;
is(&qt($tr->query('a','b',undef)), 'd', 'after refresh');

$tr = undef;
unlink($dbname);

sub qt {
    join(";", sort map {join(",",@$_)} @_);
}

sub j {join(",",sort @_)}
