# $Id: 08_qmapped.t,v 1.1 2006/06/07 12:20:58 pythontech Exp $
use strict;
use Test::More tests => 5;

use lib 't/lib';
use DbUtil;

#use PythonTech::Triples::QMap;
use PythonTech::Triples::Memory;
use PythonTech::Triples::QMapped;

my $q = bless {}, 'TestMap';	# See below
my $qt = new PythonTech::Triples::Memory();
my $mt = new PythonTech::Triples::QMapped(qtriples => $qt,
					  qmap => $q);

# Create test data
$qt->add('a:a', 's:b', 'a:c');
$qt->add('a:a', 's:b', 'd');

my @x;
$qt->iterate(undef,undef,undef,sub {push @x,join(" ",@_);undef});
is(&j(@x),"a:a s:b a:c,a:a s:b d",'all values');
@x = ();
$mt->iterate(undef,undef,undef,sub {push @x,join(" ",@_);undef});
is(&j(@x),"abc/a schema#b abc/c,abc/a schema#b d",'all values');
is($mt->test('abc/a','schema#b','abc/c'), 1, 'simple test');
is($mt->test('abc/a','schema#b','d'), 1, 'not all matched');
is(&j($mt->sp2o('abc/a','schema#b')),"abc/c,d", 'both ways');

sub j {
    join(",",sort @_);
}

#------------------------------------------------------------
package TestMap;

sub decode {
    my($self,$qname) = @_;
    if ($qname =~ m!^a:(.*)!) {
	return "abc/$1";
    } elsif ($qname =~ m!^s:(.*)!) {
	return "schema#$1";
    } else {
	return $qname;
    }
}

sub encode {
    my($self,$uri) = @_;
    if ($uri =~ m!^abc/(.*)!) {
	return "a:$1";
    } elsif ($uri =~ m!schema\#(.*)!) {
	return "s:$1";
    } else {
	return $uri;
    }
}

1;
